*Traduvox-light: Interface do google tradutor simplificada para dosvox;
*Por Fabiano Ferreira;
*Verso 0 em 09/04/2022;
*Verso 1 em 20/04/2022;

busca $dircorrente dir
chama @pegadirambiente
dir troca $dirambiente

seja $versao 1
escreve "Traduvox - Verso "$versao

*Programa principal
@inicia
Escreve "Escolha as opes de traduo ou tecle escape para sair."
chama @selecionalinguaorigem
chama @selecionalinguadestino
chama @escolheroquetraduzir

se $numeroopcao = 1
@loop_traduztextodigitado
chama @obtemtextoatraduzir
se $textoatraduzir = "" desvia @inicia

chama @traduzconteudo
chama @processaresultado
chama @mostraresultado
desvia @loop_traduztextodigitado
seno

se $numeroopcao = 2
chama @obtemarquivoatraduzir
se $arquivoatraduzir = "" desvia @inicia
Escreve "Aguarde um momento."
escreve ""
escreve "Aperte enter para saber o andamento da traduo."
escreve "Espao para ligar ou desligar o indicador de progresso."
escreve "Escape para abandonar."
chama @traduzarquivo
se $abandonartraducao = "s" escreve "Traduo de arquivo interrompida."
se $abandonartraducao <> "s" escreve "Resultado salvo em "$arquivodestino"
remove $arqtemp
desvia @inicia
seno

se $numeroopcao = 3
chama @traduzdoclipboard
escreve "Resultado copiado para  area de transferncia"
desvia @inicia
fim se

*Funes do programa

*Seleciona o idioma de origem
@selecionalinguaorigem
seja $idi1 "Alemo"
seja $idi2 "Espanhol"
seja $idi3 "Francs"
seja $idi4 "Ingls"
seja $idi5 "Italiano"
seja $idi6 "Portugus"
escreve "Selecione o idioma de origem:"
menu cria 1 1 20 6
menu adiciona $idi1
menu adiciona $idi2
menu adiciona $idi3
menu adiciona $idi4
menu adiciona $idi5
menu adiciona $idi6
@fixomenuio
menu executa $numeroio $letraio $textoio
se $letraio = "#13"
se $numeroio = 1 seja $io "de"
se $numeroio = 2 seja $io "es"
se $numeroio = 3 seja $io "fr"
se $numeroio = 4 seja $io "en"
se $numeroio = 5 seja $io "it"
se $numeroio = 6 seja $io "pt"
menu termina
 retorna
fim se
se $letraio = "#27"
escreve "Desistiu"
termina mudo
fim se
desvia @fixomenuio

*Seleciona o idioma de destino
@selecionalinguadestino
escreve "Selecione idioma de destino:"
menu cria 1 1 20 6
menu adiciona $idi1
menu adiciona $idi2
menu adiciona $idi3
menu adiciona $idi4
menu adiciona $idi5
menu adiciona $idi6
@fixomenuid
menu executa $numeroid $letraid $textoid
se $letraid = "#13"
se $numeroid = 1 seja $id "de"
se $numeroid = 2 seja $id "es"
se $numeroid = 3 seja $id "fr"
se $numeroid = 4 seja $id "en"
se $numeroid = 5 seja $id "it"
se $numeroid = 6 seja $id "pt"
menu termina
Escreve "De "$textoio" para "$textoid"."
 retorna
fim se
se $letraid = "#27"
escreve "Desistiu"
termina mudo
fim se
desvia @fixomenuid

*Escolhe uma opo de traduo: texto digitado, arquivo ou contedo da rea de transferncia;
@escolheroquetraduzir
Escreve "Escolha uma opo:"
seja $primeiraopcao "Traduzir frases"
seja $segundaopcao "Traduzir arquivo"
seja $terceiraopcao "Traduzir da rea de transferncia"
menu cria 1 1 25 3
menu adiciona $primeiraopcao
menu adiciona $segundaopcao
menu adiciona $terceiraopcao
@fixomenu_escolheroquetraduzir
menu executa $numeroopcao $letraopcao $textoopcao
se $letraopcao = "#13"
menu termina
 retorna
seno
se $letraopcao = "#27"
escreve "Desistiu"
termina mudo
seno
desvia @fixomenu_escolheroquetraduzir
fim se

*Obtem uma frase para traduzir
@obtemtextoatraduzir
escreve ""
escreve "Digite o texto a traduzir:"
le $textoatraduzir
http $textoatraduzir
retorna

*Mostra frase traduzida na tela
@mostraresultado
escreve "Editore a resposta"
escreve $resultado
le edita $resultado
retorna

*Traduz contedo da rea de transferncia
@traduzdoclipboard
seja $enter crlf
transfere para $textoatraduzir
seja t tamanho $textoatraduzir
se t >= 5000
escreve "Pode ser que o resultado saia incompleto, devido ao tamanho do contedo na rea de transferncia."
escreve "Havendo problemas, refaa a traduo usando a opo de traduzir arquivos."
fim se
substitui $textoatraduzir $enter "%0D"
http $textoatraduzir
chama @traduzconteudo
chama @processaresultado
substitui $resultado "%0D" $enter
transfere de $resultado
retorna

*Obtem um arquivo para traduzir
@obtemarquivoatraduzir
Escreve "Informe o arquivo que deseja traduzir"
le $arquivoatraduzir
dir troca $dircorrente
busca b $arquivoatraduzir
se b = ""
escreve "Arquivo no encontrado."
escreve "Verifique o caminho digitado e tente novamente."
desvia @obtemarquivoatraduzir
fim se
se $arquivoatraduzir = ""
escreve "Desistiu."
dir troca $dirambiente
fim se
retorna

*envia as linhas para traduo do arquivo
@traduzarquivo
*Cria uma cpia do arquivo origem
seja $dirtemp $dirambiente
concatena $dirtemp "\temp"
busca b dir $dirtemp
se b = "" dir cria $dirtemp
seja $arqtemp $dirtemp
concatena $arqtemp "\tdl.temp"
remove $arqtemp &
abre #2 $arqtemp &
abre #3 $arquivoatraduzir
le #3 l
checa c
enquanto c = 0
seja t tamanho l
se t >= 200
 chama @quebralinha
seno
escreve #2 l
fim se
le #3 l
checa c
fim enquanto
fecha #2
fecha #3
dir troca $dirambiente

*Descobre quantas linhas existe no arquivo temporrio
seja $novalinha "%0D"
seja $linhasenviadas 0
seja $indicaprogresso 1
seja $diferenca 0
seja $totaldelinhas 0
seja $textoatraduzir ""
seja $falaporcento 0
abre #2 $arqtemp
le #2 l
checa c
enquanto c = 0
soma $totaldelinhas 1
le #2 l
checa c
fim enquanto
fecha #2

*Cria o arquivo com o contedo traduzido
seja $dirtraduzidos $dirambiente
concatena $dirtraduzidos "\arquivos traduzidos"
busca b dir $dirtraduzidos
se b = "" dir cria $dirtraduzidos
seja $arquivodestino $dirtraduzidos
concatena $arquivodestino "\"
seja p pos "\" $arquivoatraduzir
enquanto p > 0
soma p 1
seja t tamanho $arquivoatraduzir
copia $arquivoatraduzir $arquivoatraduzir p t
seja p pos "\" $arquivoatraduzir
fim enquanto
concatena $arquivodestino $arquivoatraduzir
substitui $arquivodestino ".txt" ""
substitui $arquivodestino ".TXT" ""
concatena $arquivodestino "_"
concatena $arquivodestino $id
concatena $arquivodestino ".txt"
abre #2 $arqtemp
escreve "Iniciando a traduo"
remove $arquivodestino &
abre #3 $arquivodestino &
le #2 l
checa $acabouarquivo
enquanto $acabouarquivo = 0
observa teclado k
se k = 1 chama @monitorateclado
se $abandonartraducao = "s" retorna
soma $linhasenviadas 1
http l
seja $tamLinhaLocal tamanho l
seja $tamlinhasaenviar tamanho $textoatraduzir
seja $tamaposjuntar ($tamlinhalocal+$tamlinhasaenviar+3)
se $tamaposjuntar <= 6815
chama @fimdelinha
 concatena $textoatraduzir l
seno
chama @traduzconteudo
chama @processaresultado
escreve #3 $resultado
seja $textoatraduzir l
chama @traduzconteudo
chama @processaresultado
escreve #3 $resultado
se $indicaprogresso = 1 chama @falaquantosporcento
seja $textoatraduzir ""
fim se
le #2 l
checa $acabouarquivo
fim enquanto
fecha #2
seja t tamanho $textoatraduzir
se t > 0
chama @traduzconteudo
chama @processaresultado
escreve #3 $resultado
bipa 1
fim se
fecha #3
retorna

*Define se cria nova linha ou se vai concatenar com a prxima;
*Tenta fazer com que as linhas no acabe sem pontuao;
@fimdelinha
copia z l $tamlinhalocal $tamlinhalocal
se z = "."
concatena $textoatraduzir $novalinha
seno
se z = ":"
concatena $textoatraduzir $novalinha
seno
se z = "?"
concatena $textoatraduzir $novalinha
seno
se z = "!"
concatena $textoatraduzir $novalinha
seno
se z = ","
concatena $textoatraduzir $novalinha
seno
se z = ";"
concatena $textoatraduzir $novalinha
seno
se z = ")"
concatena $textoatraduzir $novalinha
seno
se z = "]"
concatena $textoatraduzir $novalinha
seno
se z = "}"
concatena $textoatraduzir $novalinha
seno
se z = ""
 concatena $textoatraduzir $novalinha
seno
concatena $textoatraduzir "%20"
fim se
retorna

*Verifica o teclado (usurio apertou alguma tecla durante o processo de traduo);
@monitorateclado
le mudo t &
se t = "#13"
 escreve "Traduo de arquivo em andamento"
escreve ""
escreve $quantosporcento"%"
fim se
se t = " "
 seja $indicaprogresso (($indicaprogresso*-1)+1)
se $indicaprogresso = 0 fala "Indicador de progresso desativado"
se $indicaprogresso = 1 fala "Indicador de progresso ativado"
fim se
se t = "#27"
@perguntasequerparar
escreve "Deseja parar a traduo?"
le mudo $abandonartraducao &
se $abandonartraducao =  "s" chama @abandonar
se $abandonartraducao <> "n" desvia @perguntasequerparar
fim se
bipa 1
retorna

*Aborta a traduo;
@abandonar
fecha #3
fecha #2
remove $arquivodestino
retorna

*Ajusta linhas do arquivo temporrio;
@quebralinha
seja p 200
@ajustaquebra
copia m l p p
se m = "." desvia @achoufimdalinha
se m = "," desvia @achoufimdalinha
se m = "?" desvia @achoufimdalinha
se m = "!" desvia @achoufimdalinha
se m = ":" desvia @achoufimdalinha
se m = ";" desvia @achoufimdalinha
se m = " " desvia @achoufimdalinha
subtrai p 1
desvia @ajustaquebra
fim se
@achoufimdalinha
copia m l 1 p
escreve #2 m
soma p 1
seja t tamanho l
copia l l p t
seja t tamanho l
se t >= 200
desvia @quebralinha
seno
escreve #2 l
fim se
retorna

*Indicador de progresso da traduo do arquivo;
@falaquantosporcento
seja $quantosporcento (($linhasenviadas*100)/$totaldelinhas)
seja $diferenca ($quantosporcento-$falaporcento)
se $diferenca >= 5
escreve $quantosporcento"%"
seja $falaporcento $quantosporcento
fim se
retorna

*Envia contedo ao google para traduo
@traduzconteudo
internet inicia
seja $metodo "GET "
seja $host "translate.google.com"
seja $porta 443
seja $useragent "webvox"
seja $versao_http " HTTP/1.1"
seja $recurso "/m"
seja $parametros "?sl="
concatena $parametros $io
concatena $parametros "&tl="
concatena $parametros $id
concatena $parametros "&q="
ansiparautf8 $textoatraduzir
concatena $parametros $textoatraduzir
conecta ssl #1 $host $porta &
checa $problemasaoconectar
se $problemasaoconectar = 1
bipa
espera 10
desvia @traduzconteudo
fim se
escreve #1 $metodo $recurso $parametros $versao_http
escreve #1 "Host: "$host
escreve #1 "User-Agent: "$useragent
escreve #1 "Connection: Keep-Alive"
escreve #1 "Accept: */*"
escreve #1 "Accept-Encoding: identity"
escreve #1 ""
retorna

*trata a resposta do google
@processaresultado
le #1 $resultado
enquanto no $resultado *=* """result-container"""
le #1 $resultado
fim enquanto
fecha #1

seja p pos """result-container""" $resultado
soma p 19
seja t tamanho $resultado
copia $resultado $resultado p t
seja p pos "<" $resultado
subtrai p 1
copia $resultado $resultado 1 p

utf8paraansi $resultado
substitui $resultado "&quot;" """"
substitui $resultado "&#39;" "'"
retorna

*Obtem o diretrio de incio
@pegadirambiente
seja $dirambiente ""
busca b dir "c:\winvox\traduvox-light"
se b <> ""
seja $dirambiente "c:\winvox\traduvox-light"
seno
seja $args params
seja q palavra 1 $args

se q = 0 desvia @errodirambiente
soma q 1

seja i 2
seja p palavra i $args
enquanto i <= q
substitui p "%20" " "
concatena $dirambiente p
concatena $dirambiente " "
soma i 1
seja p palavra i $args
fim enquanto
seja $dirambiente trim $dirambiente
fim se
retorna

@errodirambiente
escreve "erro."
Escreve " necessrio definir um diretrio de trabalho."
escreve "O diretrio padro c:\winvox\traduvox-light no foi encontrado."
escreve ""
escreve "Verifique a instalao do programa."
escreve "Tecle enter para fechar."
le
termina mudo
